#property indicator_chart_window
//---- input parameters
extern int nPeriod=9;
extern int Limit=350;
extern color WSO_Color=SandyBrown;
extern color WRO_Color=Aquamarine;
extern bool ShowPrice=true;
///---- int Widners Oscilator
int cnt,nCurBar=0;

string wso_name;
string wro_name;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   wso_name="HPT - WSO - " + TimeFrameToString(Period());
   wro_name="HPT - WRO - " + TimeFrameToString(Period());
   for(cnt=0; cnt<=5; cnt++)
      {
      ObjectDelete(wso_name+cnt);
      ObjectDelete(wro_name+cnt);
      }
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
   for(cnt=0; cnt<=5; cnt++)
      {
      ObjectDelete(wso_name+cnt);
      ObjectDelete(wro_name+cnt);
      }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//---- TODO: add your code here
   double r1,r2,r3,r4,r5,r6;
   int rt1,rt2,rt3,rt4,rt5,rt6;
   double s1,s2,s3,s4,s5,s6;
   int st1,st2,st3,st4,st5,st6;
//----    
if(Bars<Limit) Limit=Bars-nPeriod;
for(nCurBar=Limit; nCurBar>0; nCurBar--)
   {
   if(Low[nCurBar+(nPeriod-1)/2] == Low[Lowest(NULL,0,MODE_LOW,nPeriod,nCurBar)])
      {
      s6=s5; s5=s4; s4=s3; s3=s2; s2=s1; s1=Low[nCurBar+(nPeriod-1)/2];
      st6=st5; st5=st4; st4=st3; st3=st2; st2=st1; st1=nCurBar+(nPeriod-1)/2;
      }
   if(High[nCurBar+(nPeriod-1)/2] == High[Highest(NULL,0,MODE_HIGH,nPeriod,nCurBar)])
      {
      r6=r5; r5=r4; r4=r3; r3=r2; r2=r1; r1=High[nCurBar+(nPeriod-1)/2];
      rt6=rt5; rt5=rt4; rt4=rt3; rt3=rt2; rt2=rt1; rt1=nCurBar+(nPeriod-1)/2;
      }
   }
//---- Move Object in Chart
FormatLine(wso_name + "0",Time[st1],s1,WSO_Color);
FormatLine(wso_name + "1",Time[st2],s2,WSO_Color);
FormatLine(wso_name + "2",Time[st3],s3,WSO_Color);
FormatLine(wso_name + "3",Time[st4],s4,WSO_Color);
FormatLine(wso_name + "4",Time[st5],s5,WSO_Color);
FormatLine(wso_name + "5",Time[st6],s6,WSO_Color);
//----
FormatLine(wro_name + "0",Time[rt1],r1,WRO_Color);
FormatLine(wro_name + "1",Time[rt2],r2,WRO_Color);
FormatLine(wro_name + "2",Time[rt3],r3,WRO_Color);
FormatLine(wro_name + "3",Time[rt4],r4,WRO_Color);
FormatLine(wro_name + "4",Time[rt5],r5,WRO_Color);
FormatLine(wro_name + "5",Time[rt6],r6,WRO_Color);

//----
   return(0);
  }

void FormatLine  (string objectName,datetime dt,double price, color clr)
{
   //ObjectCreate(objectName,OBJ_HLINE,0,0,0);
   ObjectDelete(objectName);
   if (Period()==PERIOD_MN1)
   {
      int nextMonth;
      int nextYear;
      if (TimeMonth(dt)==12)
      {
         nextMonth=1;
         nextYear=TimeYear(dt)+1;
      }
      else
      {
         nextMonth=TimeMonth(dt)+1;
         nextYear=TimeYear(dt);
      }
      string strTime = nextYear + "/" + nextMonth + "/01" + " 00:00:00";  
      ObjectCreate(objectName,OBJ_TREND,0,dt,price,StrToTime(strTime),price);
   }
   else
      ObjectCreate(objectName,OBJ_TREND,0,dt,price,dt+10080*60,price);
   ObjectSet(objectName,OBJPROP_RAY,True);
   ObjectSet(objectName,OBJPROP_WIDTH,1);
   ObjectSet(objectName,OBJPROP_STYLE, STYLE_DOT);
   ObjectSet(objectName,OBJPROP_COLOR,clr);
   ObjectMove(objectName,0,dt,price);
   if (ShowPrice)
      ObjectSetText(objectName,DoubleToStr(price,Digits));
}

string TimeFrameToString(int tf)
{
   string tfs="Current time frame";
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN1";
   }
   return(tfs);
}